searchNodes=[{"ref":"VintageNet.html","title":"VintageNet","type":"module","doc":"VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features: Ethernet and WiFi support included. Extendible to other technologies Default configurations specified in your Application config Runtime updates to configurations are persisted and applied on next boot (can be disabled) Simple subscription to network status change events Connect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular) Internet connection monitoring and failure detection (currently slow and simplistic) See github.com/nerves-networking/vintage_net for more information."},{"ref":"VintageNet.html#all_interfaces/0","title":"VintageNet.all_interfaces/0","type":"function","doc":"Return a list of all interfaces on the system NOTE: This list is currently updated every 30 seconds rather than on change. Be patient."},{"ref":"VintageNet.html#configuration_valid?/2","title":"VintageNet.configuration_valid?/2","type":"function","doc":"Check if this is a valid configuration This runs the validation routines for a settings map, but doesn&#39;t try to apply them."},{"ref":"VintageNet.html#configure/2","title":"VintageNet.configure/2","type":"function","doc":"Update the settings for the specified interface"},{"ref":"VintageNet.html#configured_interfaces/0","title":"VintageNet.configured_interfaces/0","type":"function","doc":"Return a list of configured interface"},{"ref":"VintageNet.html#get/2","title":"VintageNet.get/2","type":"function","doc":"Get the current value of a network property See get_by_prefix/1 to get some or all properties."},{"ref":"VintageNet.html#get_by_prefix/1","title":"VintageNet.get_by_prefix/1","type":"function","doc":"Get a list of all properties matching the specified prefix To get a list of all known properties and their values, call VintageNet.get_by_prefix([])"},{"ref":"VintageNet.html#get_configuration/1","title":"VintageNet.get_configuration/1","type":"function","doc":"Return the settings for the specified interface"},{"ref":"VintageNet.html#info/0","title":"VintageNet.info/0","type":"function","doc":"Print the current network status"},{"ref":"VintageNet.html#ioctl/3","title":"VintageNet.ioctl/3","type":"function","doc":"Run a command on a network interface Commands are mostly network interface-specific. Also see the VintageNet PropertyTable fo getting status or registering for status changes."},{"ref":"VintageNet.html#scan/1","title":"VintageNet.scan/1","type":"function","doc":"Scan wireless interface for other access points This is a utility function for calling the :scan ioctl."},{"ref":"VintageNet.html#subscribe/1","title":"VintageNet.subscribe/1","type":"function","doc":"Subscribe to receive property change messages Messages have the form: {VintageNet, property_name, old_value, new_value, metadata}"},{"ref":"VintageNet.html#unsubscribe/1","title":"VintageNet.unsubscribe/1","type":"function","doc":"Stop subscribing to property change messages"},{"ref":"VintageNet.html#verify_system/1","title":"VintageNet.verify_system/1","type":"function","doc":"Check that the system has the required programs installed NOTE: This isn&#39;t completely implemented yet!"},{"ref":"VintageNet.html#t:ifname/0","title":"VintageNet.ifname/0","type":"type","doc":"A name for the network interface Names depend on the device drivers and any software that may rename them. Typical names on Nerves are: &quot;eth0&quot;, &quot;eth1&quot;, etc. for wired Ethernet interfaces &quot;wlan0&quot;, etc. for WiFi interfaces &quot;ppp0&quot; for cellular modems &quot;usb0&quot; for gadget USB virtual Ethernet interfaces"},{"ref":"VintageNet.IP.ConfigToInterfaces.html","title":"VintageNet.IP.ConfigToInterfaces","type":"module","doc":"This is a helper module for VintageNet.Technology implementations that use IPv4."},{"ref":"VintageNet.IP.ConfigToInterfaces.html#config_to_interfaces_contents/2","title":"VintageNet.IP.ConfigToInterfaces.config_to_interfaces_contents/2","type":"function","doc":"Convert a configuration to the contents of a /etc/interfaces file The IPv4 configuration should be specified in the map under the :ipv4 key. Fields are: :method - :dhcp or :static If method: :static, then the following addition fields are checked: :address - IPv4 address as a string :netmask - IPv4 netmask as a string :broadcast - IPv4 broadcast address as a string :metric - Route metric (TODO: THIS WON&#39;T WORK) :gateway - Default gateway (TODO: THIS WON&#39;T WORK) :pointopoint - Address of the other end point :hwaddress - Set the MAC address :mtu - Set the MTU :scope - Route scope (TODO: THIS WON&#39;T WORK)"},{"ref":"VintageNet.IP.ConfigToUdhcpd.html","title":"VintageNet.IP.ConfigToUdhcpd","type":"module","doc":"This is a helper module for VintageNet.Technology implementations that use the udhcpd server."},{"ref":"VintageNet.IP.ConfigToUdhcpd.html#config_to_udhcpd_contents/3","title":"VintageNet.IP.ConfigToUdhcpd.config_to_udhcpd_contents/3","type":"function","doc":"Convert a configuration to the contents of a /etc/udhcpd.conf file start - Start of the lease block end - End of the lease block max_leases - The maximum number of leases decline_time - The amount of time that an IP will be reserved (leased to nobody) conflict_time -The amount of time that an IP will be reserved offer_time - How long an offered address is reserved (seconds) min_lease - If client asks for lease below this value, it will be rounded up to this value (seconds) auto_time - The time period at which udhcpd will write out leases file. static_leases - list of {macaddress, ipaddress}"},{"ref":"VintageNet.Interface.html","title":"VintageNet.Interface","type":"module","doc":"Manage a network interface at a very high level This module handles configuring network interfaces, making sure that configuration failures get retried, and then cleaning up after it&#39;s not needed. The actual code that supplies the configuration implements the VintageNet.Technology behaviour."},{"ref":"VintageNet.Interface.html#callback_mode/0","title":"VintageNet.Interface.callback_mode/0","type":"function","doc":""},{"ref":"VintageNet.Interface.html#child_spec/1","title":"VintageNet.Interface.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor in Elixir v1.6+."},{"ref":"VintageNet.Interface.html#configure/1","title":"VintageNet.Interface.configure/1","type":"function","doc":"Configure an interface the low level way with a &quot;raw_config&quot;"},{"ref":"VintageNet.Interface.html#configure/2","title":"VintageNet.Interface.configure/2","type":"function","doc":"Set a configuration on an interface"},{"ref":"VintageNet.Interface.html#get_configuration/1","title":"VintageNet.Interface.get_configuration/1","type":"function","doc":"Return the current configuration"},{"ref":"VintageNet.Interface.html#ioctl/3","title":"VintageNet.Interface.ioctl/3","type":"function","doc":"Run an I/O command on the specified interface"},{"ref":"VintageNet.Interface.html#start_link/1","title":"VintageNet.Interface.start_link/1","type":"function","doc":"Start up an interface Parameters: ifname - which interface"},{"ref":"VintageNet.Interface.html#stop/1","title":"VintageNet.Interface.stop/1","type":"function","doc":"Stop the interface Note that this doesn&#39;t unconfigure it."},{"ref":"VintageNet.Interface.html#to_raw_config/2","title":"VintageNet.Interface.to_raw_config/2","type":"function","doc":"Convert a configuration to a raw one This can be used to validate a configuration without applying it."},{"ref":"VintageNet.Interface.html#unconfigure/1","title":"VintageNet.Interface.unconfigure/1","type":"function","doc":"Unconfigure the interface This doesn&#39;t exit this GenServer, but the interface won&#39;t be usable in any real way until it&#39;s configured again. This function is not normally called."},{"ref":"VintageNet.Interface.html#wait_until_configured/1","title":"VintageNet.Interface.wait_until_configured/1","type":"function","doc":"Wait for the interface to be configured"},{"ref":"VintageNet.Interface.Classification.html","title":"VintageNet.Interface.Classification","type":"module","doc":"Module for classifying and prioritizing network interfaces"},{"ref":"VintageNet.Interface.Classification.html#compute_metric/3","title":"VintageNet.Interface.Classification.compute_metric/3","type":"function","doc":"Compute the routing metric for an interface with a status This uses the prioritization list to figure out what number should be used for the Linux routing table metric. It could also be :disabled to indicate that a route shouldn&#39;t be added to the Linux routing tables at all."},{"ref":"VintageNet.Interface.Classification.html#default_prioritization/0","title":"VintageNet.Interface.Classification.default_prioritization/0","type":"function","doc":"Return a reasonable default for prioritizing interfaces The logic is that Internet-connected interfaces are prioritized first and after than Ethernet is preferred over WiFi and WiFi over LTE."},{"ref":"VintageNet.Interface.Classification.html#to_type/1","title":"VintageNet.Interface.Classification.to_type/1","type":"function","doc":"Classify a network type based on its name Examples iex&gt; Classification.to_type(&quot;eth0&quot;) :ethernet iex&gt; Classification.to_type(&quot;wlp5s0&quot;) :wifi iex&gt; Classification.to_type(&quot;ppp0&quot;) :mobile"},{"ref":"VintageNet.Interface.Classification.html#t:connection_status/0","title":"VintageNet.Interface.Classification.connection_status/0","type":"type","doc":"Interface connection status :disconnected - The interface doesn&#39;t exist or it&#39;s not connected :lan - The interface is connected to the LAN, but may not be able reach the Internet :internet - Packets going through the interface should be able to reach the Internet"},{"ref":"VintageNet.Interface.Classification.html#t:interface_type/0","title":"VintageNet.Interface.Classification.interface_type/0","type":"type","doc":"Categorize interfaces based on their technology"},{"ref":"VintageNet.Interface.Classification.html#t:prioritization/0","title":"VintageNet.Interface.Classification.prioritization/0","type":"type","doc":"Prioritization for using default gateways Examples {:ethernet, :internet} - Wired ethernet that&#39;s Internet connected {:ethernet, :_} - Wired ethernet with any status {:_, :internet} - Any Internet-connected network interface"},{"ref":"VintageNet.Interface.CommandRunner.html","title":"VintageNet.Interface.CommandRunner","type":"module","doc":"The CommandRunner module runs commands specified in RawConfigs See the RawConfig documentation for where lists of commands are specified. The following commands are supported: {:run, command, args} - Run a system command {:run_ignore_exit, command, args} - Same as :run, but without the exit status check {:fun, fun} - Run an function CommandRunner also implements RawConfig&#39;s file creation and cleanup logic."},{"ref":"VintageNet.Interface.CommandRunner.html#create_files/1","title":"VintageNet.Interface.CommandRunner.create_files/1","type":"function","doc":"Create a list of files"},{"ref":"VintageNet.Interface.CommandRunner.html#remove_files/1","title":"VintageNet.Interface.CommandRunner.remove_files/1","type":"function","doc":"Remove a list of files"},{"ref":"VintageNet.Interface.CommandRunner.html#run/1","title":"VintageNet.Interface.CommandRunner.run/1","type":"function","doc":"Run an arbitrary function In general, try to avoid using this. VintageNet&#39;s unit test strategy is to verify configurations rather than verify the execution of the configurations. Functions can&#39;t be checked that they were created correctly. Functions must return :ok or {:error, reason}."},{"ref":"VintageNet.Interface.ConnectivityChecker.html","title":"VintageNet.Interface.ConnectivityChecker","type":"module","doc":""},{"ref":"VintageNet.Interface.ConnectivityChecker.html#child_spec/1","title":"VintageNet.Interface.ConnectivityChecker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.Interface.ConnectivityChecker.html#hostent/2","title":"VintageNet.Interface.ConnectivityChecker.hostent/2","type":"macro","doc":""},{"ref":"VintageNet.Interface.ConnectivityChecker.html#start_link/1","title":"VintageNet.Interface.ConnectivityChecker.start_link/1","type":"function","doc":"Start the connectivity checker GenServer"},{"ref":"VintageNet.Interface.RawConfig.html","title":"VintageNet.Interface.RawConfig","type":"module","doc":"Raw configuration for an interface This struct contains the low-level instructions for how to configure and unconfigure an interface. Fields: ifname - the name of the interface (e.g., &quot;eth0&quot;) type - the type of network interface (aka the module that created the config) source_config - the configuration that generated this one require_interface - require the interface to exist in the system before configuring retry_millis - if bringing the interface up fails, wait this amount of time before retrying files - a list of file path, content tuples up_cmd_millis - the maximum amount of time to allow the up command list to take up_cmds - a list of commands to run to configure the interface down_cmd_millis - the maximum amount of time to allow the down command list to take down_cmds - a list of commands to run to unconfigure the interface cleanup_files - additional files to delete (the files listed in files are deleted too)"},{"ref":"VintageNet.Interface.RawConfig.html#unimplemented_ioctl/2","title":"VintageNet.Interface.RawConfig.unimplemented_ioctl/2","type":"function","doc":""},{"ref":"VintageNet.Interface.RawConfig.html#t:command/0","title":"VintageNet.Interface.RawConfig.command/0","type":"type","doc":""},{"ref":"VintageNet.Interface.RawConfig.html#t:file_contents/0","title":"VintageNet.Interface.RawConfig.file_contents/0","type":"type","doc":""},{"ref":"VintageNet.Interface.RawConfig.html#t:t/0","title":"VintageNet.Interface.RawConfig.t/0","type":"type","doc":""},{"ref":"VintageNet.Interface.Supervisor.html","title":"VintageNet.Interface.Supervisor","type":"module","doc":""},{"ref":"VintageNet.Interface.Supervisor.html#child_spec/1","title":"VintageNet.Interface.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.Interface.Supervisor.html#clear_technology/1","title":"VintageNet.Interface.Supervisor.clear_technology/1","type":"function","doc":"Clear out children and child_specs from a technology"},{"ref":"VintageNet.Interface.Supervisor.html#set_technology/2","title":"VintageNet.Interface.Supervisor.set_technology/2","type":"function","doc":"Add child_specs provided by technologies to supervision"},{"ref":"VintageNet.Interface.Supervisor.html#start_link/1","title":"VintageNet.Interface.Supervisor.start_link/1","type":"function","doc":"Start the interface supervisor"},{"ref":"VintageNet.Interface.Udhcpc.html","title":"VintageNet.Interface.Udhcpc","type":"module","doc":""},{"ref":"VintageNet.Interface.Udhcpc.html#bound/2","title":"VintageNet.Interface.Udhcpc.bound/2","type":"function","doc":""},{"ref":"VintageNet.Interface.Udhcpc.html#deconfig/2","title":"VintageNet.Interface.Udhcpc.deconfig/2","type":"function","doc":""},{"ref":"VintageNet.Interface.Udhcpc.html#leasefail/2","title":"VintageNet.Interface.Udhcpc.leasefail/2","type":"function","doc":""},{"ref":"VintageNet.Interface.Udhcpc.html#nak/2","title":"VintageNet.Interface.Udhcpc.nak/2","type":"function","doc":""},{"ref":"VintageNet.Interface.Udhcpc.html#renew/2","title":"VintageNet.Interface.Udhcpc.renew/2","type":"function","doc":""},{"ref":"VintageNet.InterfacesMonitor.html","title":"VintageNet.InterfacesMonitor","type":"module","doc":"Monitor available interfaces Currently this works by polling the system for what interfaces are visible. They may or may not be configured."},{"ref":"VintageNet.InterfacesMonitor.html#child_spec/1","title":"VintageNet.InterfacesMonitor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.InterfacesMonitor.html#interfaces/0","title":"VintageNet.InterfacesMonitor.interfaces/0","type":"function","doc":"Return a list of interfaces"},{"ref":"VintageNet.InterfacesMonitor.html#start_link/1","title":"VintageNet.InterfacesMonitor.start_link/1","type":"function","doc":""},{"ref":"VintageNet.InterfacesSupervisor.html","title":"VintageNet.InterfacesSupervisor","type":"module","doc":""},{"ref":"VintageNet.InterfacesSupervisor.html#child_spec/1","title":"VintageNet.InterfacesSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.InterfacesSupervisor.html#start_interface/1","title":"VintageNet.InterfacesSupervisor.start_interface/1","type":"function","doc":""},{"ref":"VintageNet.InterfacesSupervisor.html#start_link/1","title":"VintageNet.InterfacesSupervisor.start_link/1","type":"function","doc":""},{"ref":"VintageNet.NameResolver.html","title":"VintageNet.NameResolver","type":"module","doc":"This module manages the contents of &quot;/etc/resolv.conf&quot;. This file is used by the C library for resolving domain names and must be kept up-to-date as links go up and down. This module assumes exclusive ownership on &quot;/etc/resolv.conf&quot;, so if any other code in the system tries to modify the file, their changes will be lost on the next update."},{"ref":"VintageNet.NameResolver.html#child_spec/1","title":"VintageNet.NameResolver.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.NameResolver.html#clear/1","title":"VintageNet.NameResolver.clear/1","type":"function","doc":"Clear all entries in &quot;/etc/resolv.conf&quot; that are associated with the specified interface."},{"ref":"VintageNet.NameResolver.html#clear_all/0","title":"VintageNet.NameResolver.clear_all/0","type":"function","doc":"Completely clear out &quot;/etc/resolv.conf&quot;."},{"ref":"VintageNet.NameResolver.html#setup/3","title":"VintageNet.NameResolver.setup/3","type":"function","doc":"Set the search domain and nameserver list for the specified interface. This replaces any entries in the /etc/resolv.conf for this interface."},{"ref":"VintageNet.NameResolver.html#start_link/1","title":"VintageNet.NameResolver.start_link/1","type":"function","doc":"Start the resolv.conf manager."},{"ref":"VintageNet.NameResolver.html#stop/0","title":"VintageNet.NameResolver.stop/0","type":"function","doc":"Stop the resolv.conf manager."},{"ref":"VintageNet.NameResolver.html#t:ifmap/0","title":"VintageNet.NameResolver.ifmap/0","type":"type","doc":"Settings for NameResolver"},{"ref":"VintageNet.NameResolver.html#t:state/0","title":"VintageNet.NameResolver.state/0","type":"type","doc":"State of the server."},{"ref":"VintageNet.Persistence.html","title":"VintageNet.Persistence","type":"behaviour","doc":"Customize the way VintageNet saves and loads configurations"},{"ref":"VintageNet.Persistence.html#call/2","title":"VintageNet.Persistence.call/2","type":"function","doc":""},{"ref":"VintageNet.Persistence.html#c:clear/1","title":"VintageNet.Persistence.clear/1","type":"callback","doc":"Clear out a previously saved configuration"},{"ref":"VintageNet.Persistence.html#c:enumerate/0","title":"VintageNet.Persistence.enumerate/0","type":"callback","doc":"Enumerate the interfaces that have saved configurations This returns a list of interface names."},{"ref":"VintageNet.Persistence.html#c:load/1","title":"VintageNet.Persistence.load/1","type":"callback","doc":"Load the configuration of an interface"},{"ref":"VintageNet.Persistence.html#c:save/2","title":"VintageNet.Persistence.save/2","type":"callback","doc":"Save the configuration for the specified interface"},{"ref":"VintageNet.Persistence.FlatFile.html","title":"VintageNet.Persistence.FlatFile","type":"module","doc":"Save and load configurations from flat files"},{"ref":"VintageNet.PropertyTable.html","title":"VintageNet.PropertyTable","type":"module","doc":"PropertyTables are in-memory key-value stores Users can subscribe to keys or groups of keys to be notified of changes. Keys are hierarchically layed out with each key being represented as a list for the path to the key. For example, to get the current state of the network interface eth0, you would get the value of the key, [&quot;net&quot;, &quot;ethernet&quot;, &quot;eth0&quot;]. Values can be any Elixir data structure except for nil. nil is used to identify non-existent keys. Therefore, setting a property to nil deletes the property. Users can get and listen for changes in multiple keys by specifying prefix paths. For example, if you wants to get every network property, run: PropertyTable.get_by_prefix(table, [&quot;net&quot;]) Likewise, you can subscribe to changes in the network status by running: PropertyTable.subscribe(table, [&quot;net&quot;]) Properties can include metadata. PropertyTable only specifies that metadata is a map."},{"ref":"VintageNet.PropertyTable.html#child_spec/1","title":"VintageNet.PropertyTable.child_spec/1","type":"function","doc":"Returns a specification to start a property_table under a supervisor. See Supervisor."},{"ref":"VintageNet.PropertyTable.html#clear/2","title":"VintageNet.PropertyTable.clear/2","type":"function","doc":"Clear out a property"},{"ref":"VintageNet.PropertyTable.html#clear_prefix/2","title":"VintageNet.PropertyTable.clear_prefix/2","type":"function","doc":"Clear out all properties under a prefix"},{"ref":"VintageNet.PropertyTable.html#get/3","title":"VintageNet.PropertyTable.get/3","type":"function","doc":"Get the current value of a property"},{"ref":"VintageNet.PropertyTable.html#get_by_prefix/2","title":"VintageNet.PropertyTable.get_by_prefix/2","type":"function","doc":"Get a list of all properties matching the specified prefix"},{"ref":"VintageNet.PropertyTable.html#put/4","title":"VintageNet.PropertyTable.put/4","type":"function","doc":"Update a property and notify listeners"},{"ref":"VintageNet.PropertyTable.html#start_link/1","title":"VintageNet.PropertyTable.start_link/1","type":"function","doc":""},{"ref":"VintageNet.PropertyTable.html#subscribe/2","title":"VintageNet.PropertyTable.subscribe/2","type":"function","doc":"Subscribe to receive events"},{"ref":"VintageNet.PropertyTable.html#unsubscribe/2","title":"VintageNet.PropertyTable.unsubscribe/2","type":"function","doc":"Stop subscribing to a property"},{"ref":"VintageNet.PropertyTable.html#t:metadata/0","title":"VintageNet.PropertyTable.metadata/0","type":"type","doc":""},{"ref":"VintageNet.PropertyTable.html#t:property/0","title":"VintageNet.PropertyTable.property/0","type":"type","doc":"Properties"},{"ref":"VintageNet.PropertyTable.html#t:table_id/0","title":"VintageNet.PropertyTable.table_id/0","type":"type","doc":"A table_id identifies a group of properties"},{"ref":"VintageNet.PropertyTable.html#t:value/0","title":"VintageNet.PropertyTable.value/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html","title":"VintageNet.Route.Calculator","type":"module","doc":"This module computes the desired routing table contents It&#39;s used by the RouteManager to update the Linux routing tables when interfaces come online or change state. See the RouteManager docs for a discussion of how routes are configured. The functions in this module have no side effects so that it&#39;s easier to test that routing scenarios result in correct Linux routing table configurations."},{"ref":"VintageNet.Route.Calculator.html#compute/3","title":"VintageNet.Route.Calculator.compute/3","type":"function","doc":"Compute a Linux routing table configuration The entries are ordered so that List.myers_difference/2 can be used to minimize the routing table changes."},{"ref":"VintageNet.Route.Calculator.html#init/0","title":"VintageNet.Route.Calculator.init/0","type":"function","doc":"Initialize state carried between calculations"},{"ref":"VintageNet.Route.Calculator.html#to_subnet/2","title":"VintageNet.Route.Calculator.to_subnet/2","type":"function","doc":"Utility function to trim IP address to its subnet Examples: iex&gt; Calculator.to_subnet({192, 168, 1, 50}, 24) {192, 168, 1, 0} iex&gt; Calculator.to_subnet({192, 168, 255, 50}, 22) {192, 168, 252, 0}"},{"ref":"VintageNet.Route.Calculator.html#t:default_route/0","title":"VintageNet.Route.Calculator.default_route/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:entries/0","title":"VintageNet.Route.Calculator.entries/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:entry/0","title":"VintageNet.Route.Calculator.entry/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:interface_infos/0","title":"VintageNet.Route.Calculator.interface_infos/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:local_route/0","title":"VintageNet.Route.Calculator.local_route/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:metric/0","title":"VintageNet.Route.Calculator.metric/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:rule/0","title":"VintageNet.Route.Calculator.rule/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:subnet_bits/0","title":"VintageNet.Route.Calculator.subnet_bits/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:table_index/0","title":"VintageNet.Route.Calculator.table_index/0","type":"type","doc":""},{"ref":"VintageNet.Route.Calculator.html#t:table_indices/0","title":"VintageNet.Route.Calculator.table_indices/0","type":"type","doc":""},{"ref":"VintageNet.Route.IPRoute.html","title":"VintageNet.Route.IPRoute","type":"module","doc":"This module knows how to invoke ip to change the routing table"},{"ref":"VintageNet.Route.IPRoute.html#add_default_route/4","title":"VintageNet.Route.IPRoute.add_default_route/4","type":"function","doc":"Add a default route"},{"ref":"VintageNet.Route.IPRoute.html#add_local_route/4","title":"VintageNet.Route.IPRoute.add_local_route/4","type":"function","doc":"Add a local route"},{"ref":"VintageNet.Route.IPRoute.html#add_rule/2","title":"VintageNet.Route.IPRoute.add_rule/2","type":"function","doc":"Add a source IP address -&gt; routing table rule"},{"ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/1","title":"VintageNet.Route.IPRoute.clear_a_local_route/1","type":"function","doc":""},{"ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/4","title":"VintageNet.Route.IPRoute.clear_a_local_route/4","type":"function","doc":""},{"ref":"VintageNet.Route.IPRoute.html#clear_a_route/0","title":"VintageNet.Route.IPRoute.clear_a_route/0","type":"function","doc":""},{"ref":"VintageNet.Route.IPRoute.html#clear_a_route/2","title":"VintageNet.Route.IPRoute.clear_a_route/2","type":"function","doc":""},{"ref":"VintageNet.Route.IPRoute.html#clear_a_rule/1","title":"VintageNet.Route.IPRoute.clear_a_rule/1","type":"function","doc":""},{"ref":"VintageNet.Route.IPRoute.html#clear_all_routes/0","title":"VintageNet.Route.IPRoute.clear_all_routes/0","type":"function","doc":"Clear all routes on all interfaces"},{"ref":"VintageNet.Route.IPRoute.html#clear_all_rules/1","title":"VintageNet.Route.IPRoute.clear_all_rules/1","type":"function","doc":"Clear all rules that select the specified table or tables"},{"ref":"VintageNet.Route.InterfaceInfo.html","title":"VintageNet.Route.InterfaceInfo","type":"module","doc":""},{"ref":"VintageNet.Route.InterfaceInfo.html#metric/2","title":"VintageNet.Route.InterfaceInfo.metric/2","type":"function","doc":""},{"ref":"VintageNet.Route.InterfaceInfo.html#t:t/0","title":"VintageNet.Route.InterfaceInfo.t/0","type":"type","doc":""},{"ref":"VintageNet.Route.Properties.html","title":"VintageNet.Route.Properties","type":"module","doc":"This module contains helpers for updating the global routing properties. These include: [&quot;available_interfaces&quot;] [&quot;connection&quot;]"},{"ref":"VintageNet.Route.Properties.html#update_available_interfaces/1","title":"VintageNet.Route.Properties.update_available_interfaces/1","type":"function","doc":"Update the available_interfaces property based on the low level routes This function orders interfaces based on metric just like Linux does"},{"ref":"VintageNet.Route.Properties.html#update_best_connection/1","title":"VintageNet.Route.Properties.update_best_connection/1","type":"function","doc":"Update the overall connection status :disconnected &lt; :lan &lt; :internet"},{"ref":"VintageNet.RouteManager.html","title":"VintageNet.RouteManager","type":"module","doc":"This module manages the default route. Devices with more than one network interface may have more than one way of reaching the Internet. The routing table decides which interface an IP packet should use by looking at the &quot;default route&quot; entries. One interface is chosen. Since not all interfaces are equal, we&#39;d like Linux to pick the fastest and lowest latency one. for example, one could prefer wired Ethernet over WiFi and prefer WiFi over a cellular connection. This module lets you specify an ordering for interfaces and sets up the routes based on this ordering. This module also handles networking failures. One failure that Linux can&#39;t figure out on its own is whether an interface can reach the Internet. Internet reachability is handled elsewhere like in the ConnectivityChecker module. This module should be told reachability status so that it can properly order default routes so that the best reachable interface is used. IMPORTANT: This module uses priority-based routing. Make sure the following kernel options are enabled: CONFIG_IP_ADVANCED_ROUTER=y CONFIG_IP_MULTIPLE_TABLES=y"},{"ref":"VintageNet.RouteManager.html#child_spec/1","title":"VintageNet.RouteManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.RouteManager.html#clear_route/1","title":"VintageNet.RouteManager.clear_route/1","type":"function","doc":"Clear out the default gateway for an interface."},{"ref":"VintageNet.RouteManager.html#set_connection_status/2","title":"VintageNet.RouteManager.set_connection_status/2","type":"function","doc":"Set the connection status on an interface. Changing the connection status can re-prioritize routing. The specified interface doesn&#39;t need to have a default route."},{"ref":"VintageNet.RouteManager.html#set_prioritization/1","title":"VintageNet.RouteManager.set_prioritization/1","type":"function","doc":"Set the order that default gateways should be used The list is ordered from highest priority to lowest"},{"ref":"VintageNet.RouteManager.html#set_route/4","title":"VintageNet.RouteManager.set_route/4","type":"function","doc":"Set the default route for an interface. This replaces any existing routes on that interface"},{"ref":"VintageNet.RouteManager.html#start_link/1","title":"VintageNet.RouteManager.start_link/1","type":"function","doc":"Start the route manager."},{"ref":"VintageNet.RouteManager.html#stop/0","title":"VintageNet.RouteManager.stop/0","type":"function","doc":"Stop the route manager."},{"ref":"VintageNet.Technology.html","title":"VintageNet.Technology","type":"behaviour","doc":"Technologies define how network interface types work VintageNet comes with several built-in technologies, but more can be added or existing ones modified by implementing the Technology behaviour."},{"ref":"VintageNet.Technology.html#c:check_system/1","title":"VintageNet.Technology.check_system/1","type":"callback","doc":"Check that the system has all of the required programs for this technology This is intended to help identify missing programs without configuring a network."},{"ref":"VintageNet.Technology.html#c:ioctl/3","title":"VintageNet.Technology.ioctl/3","type":"callback","doc":"Handle an ioctl that has been requested on the network interface The function runs isolated in its own process and only one ioctl is guaranteed to be running at a time. VintageNet will handle crashes and hangs and unceremoniously kill the ioctl if the user changes their mind and reconfigures the network interface. Ioctl support is optional. Examples of ioctls include: :scan - scan for WiFi networks :statistics - return a map of network statistics"},{"ref":"VintageNet.Technology.html#c:to_raw_config/3","title":"VintageNet.Technology.to_raw_config/3","type":"callback","doc":"Convert a technology-specific configuration to one for VintageNet"},{"ref":"VintageNet.Technology.Ethernet.html","title":"VintageNet.Technology.Ethernet","type":"module","doc":""},{"ref":"VintageNet.Technology.Mobile.html","title":"VintageNet.Technology.Mobile","type":"module","doc":""},{"ref":"VintageNet.Technology.Null.html","title":"VintageNet.Technology.Null","type":"module","doc":"An interface with this technology is unconfigured"},{"ref":"VintageNet.Technology.WiFi.html","title":"VintageNet.Technology.WiFi","type":"module","doc":""},{"ref":"VintageNet.ToElixir.Server.html","title":"VintageNet.ToElixir.Server","type":"module","doc":"This GenServer routes messages from C and shell scripts to the appropriate places in VintageNet."},{"ref":"VintageNet.ToElixir.Server.html#child_spec/1","title":"VintageNet.ToElixir.Server.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"VintageNet.ToElixir.Server.html#start_link/1","title":"VintageNet.ToElixir.Server.start_link/1","type":"function","doc":"Start the GenServer."},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html","title":"VintageNet.ToElixir.UdhcpcHandler","type":"behaviour","doc":"A behaviour for handling notifications from udhcpc Example defmodule MyApp.UdhcpcHandler do @behaviour VintageNet.ToElixir.UdhcpcHandler @impl true def deconfig(data) do ... end end To have NervesHub invoke it, add the following to your config.exs: config :vintage_net, udhcpc_handler: MyApp.UdhcpcHandler"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:bound/2","title":"VintageNet.ToElixir.UdhcpcHandler.bound/2","type":"callback","doc":""},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:deconfig/2","title":"VintageNet.ToElixir.UdhcpcHandler.deconfig/2","type":"callback","doc":""},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#dispatch/3","title":"VintageNet.ToElixir.UdhcpcHandler.dispatch/3","type":"function","doc":"Called internally by vintage_net to dispatch calls"},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:leasefail/2","title":"VintageNet.ToElixir.UdhcpcHandler.leasefail/2","type":"callback","doc":""},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:nak/2","title":"VintageNet.ToElixir.UdhcpcHandler.nak/2","type":"callback","doc":""},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:renew/2","title":"VintageNet.ToElixir.UdhcpcHandler.renew/2","type":"callback","doc":""},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#t:ifname/0","title":"VintageNet.ToElixir.UdhcpcHandler.ifname/0","type":"type","doc":""},{"ref":"VintageNet.ToElixir.UdhcpcHandler.html#t:update_data/0","title":"VintageNet.ToElixir.UdhcpcHandler.update_data/0","type":"type","doc":""},{"ref":"VintageNet.WiFi.AccessPoint.html","title":"VintageNet.WiFi.AccessPoint","type":"module","doc":"Information about a WiFi access point"},{"ref":"VintageNet.WiFi.AccessPoint.html#t:t/0","title":"VintageNet.WiFi.AccessPoint.t/0","type":"type","doc":""},{"ref":"VintageNet.WiFi.Scan.html","title":"VintageNet.WiFi.Scan","type":"module","doc":""},{"ref":"VintageNet.WiFi.Scan.html#parse/1","title":"VintageNet.WiFi.Scan.parse/1","type":"function","doc":"Parse results from wpa_cli into a list of access points"},{"ref":"VintageNet.WiFi.Scan.html#scan/2","title":"VintageNet.WiFi.Scan.scan/2","type":"function","doc":"Scan wireless interface for other access points"},{"ref":"VintageNet.WiFi.WPA2.html","title":"VintageNet.WiFi.WPA2","type":"module","doc":"WPA2 preshared key calculations WPA2 doesn&#39;t use passphrases directly, but instead hashes them with the SSID and uses the result for the network key. The algorithm that runs the hash takes some time so it&#39;s useful to compute the PSK from the passphrase once rather than specifying it each time."},{"ref":"VintageNet.WiFi.WPA2.html#to_psk/2","title":"VintageNet.WiFi.WPA2.to_psk/2","type":"function","doc":"Convert a WiFi WPA2 passphrase into a PSK If a passphrase looks like a PSK, then it&#39;s assumed that it already is a PSK and is passed through. See IEEE Std 802.11i-2004 Appendix H.4 for the algorithm."},{"ref":"VintageNet.WiFi.WPA2.html#t:psk/0","title":"VintageNet.WiFi.WPA2.psk/0","type":"type","doc":"A WPA2 preshared key"},{"ref":"readme.html","title":"🍇 VintageNet","type":"extras","doc":"🍇 VintageNet NOTE: This library is very much a work in progress without sufficient documentation. It will get there, but the current Nerves libraries are much more stable, tested for what they do, and integrated into most other Nerves libraries and examples. Most importantly, the official Nerves systems do not contain some of the programs and kernel configuration needed to make this work. VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features: Ethernet and WiFi support included. Extendible to other technologies Default configurations specified in your Application config Runtime updates to configurations are persisted and applied on next boot (configurations are obfuscated by default to hide WiFi passphrases) Simple subscription to network status change events Connect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular) Internet connection monitoring and failure detection (currently slow and simplistic) The following network configurations are supported: [x] Wired Ethernet, IPv4 DHCP [ ] Wired Ethernet, IPv4 static IP [x] WiFi password-less and WEP [x] WPA2 PSK and EAP [ ] USB gadget mode Ethernet, IPv4 DHCP server to supply host IP address [ ] Cellular networks [x] WiFi AP mode [ ] IPv6 VintageNet takes a different approach to networking from nerves_network. It supports calling &quot;old school&quot; Linux utilities like ifup and ifdown to configure networks. While this isn&#39;t ideal, some network configurations are only documented for Linux systems and this can be a huge timesaver for getting an unusual network configuration working. VintageNet supports a migration path to pulling configuration back into Elixir piecemeal. Additionally, VintageNet doesn&#39;t attempt to make incremental modifications to configurations. It completely tears down an interface&#39;s connection and then brings up new configurations in a fresh state. Network reconfiguration is assumed to be an infrequent event so while this can cause a hiccup in the network connectivity, it removes most of the state machine code that made nerves_network hard to maintain."},{"ref":"readme.html#installation","title":"🍇 VintageNet - Installation","type":"extras","doc":"The vintage_net and nerves_init_gadget packages are not compatible. If you are using nerves_init_gadget, you will need to remove it from your dependency list and add back in things it supplies like nerves_runtime and nerves_firmware_ssh. When available in Hex, the package can be installed by adding vintage_net to your list of dependencies in mix.exs: def deps do [ {:vintage_net, &quot;~&gt; 0.1.0&quot;, targets: @all_targets} ] end Erlang/OTP provides many libraries for debugging networking issues. You may also want to add Toolshed to your dependencies so that you can have more familiar looking tools like ifconfig and ping at the IEx prompt."},{"ref":"readme.html#configuration","title":"🍇 VintageNet - Configuration","type":"extras","doc":"VintageNet has many application configuration keys. Most defaults are fine. At a minimum, you&#39;ll want to specify a default configuration and default regulatory domain if using WiFi. In your main config.exs, add the following: config :vintage_net, regulatory_domain: &quot;US&quot;, config: [ {&quot;eth0&quot;, %{type: VintageNet.Technology.Ethernet, ipv4: %{method: :dhcp}}}, {&quot;wlan0&quot;, %{type: VintageNet.Technology.WiFi}} ] This sets the regulatory domain to the US (set to your ISO 3166-1 alpha-2 country code. This code is passed on to the drivers for WiFi and other wireless networking technologies so that they comply with local regulations. If you need a global default, set to &quot;00&quot; or don&#39;t set at all. Unfortunately, this may mean that an access point isn&#39;t visible if it is running on a frequency that&#39;s allowed in your country, but not globally. The config section is a list of network configurations. The one shown above configures DHCP on wired Ethernet and minimally starts up a WiFi LAN so that it&#39;s possible to scan for networks. Details on network configuration are described later. The following table describes the other application config keys. KeyDescription configA list of default network configurations tmpdirPath to a temporary directory for VintageNet to_elixir_socketName to use for the Unix domain socket for C to Elixir communication bin_ifupPath to ifup bin_ifdownPath to ifdown bin_chatPath to chat bin_pppdPath to pppd bin_mknodPath to mknod bin_killallPath to killall bin_wpa_supplicantPath to wpa_supplicant bin_wpa_cliPath to wpa_cli bin_ipPath to ip udhcpc_handlerModule for handling notifications from udhcpc resolvconfPath to /etc/resolv.conf persistenceModule for persisting network configurations persistence_dirPath to a directory for storing persisted configurations persistence_secretA 16-byte secret or an MFA for getting a secret internet_hostIP address for host to ping to check for Internet connectivity regulatory_domainISO 3166-1 alpha-2 country (00 for global, US, etc.)"},{"ref":"readme.html#network-interface-configuration","title":"🍇 VintageNet - Network interface configuration","type":"extras","doc":"VintageNet supports several network technologies out of the box and third-party libraries can provide more via the VintageNet.Technology behaviour. Configurations are Elixir maps. These are specified in three places: The vintage_net application config (e.g., your config.exs) Locally saved configuration (see the VintageNet.Persistence behaviour for replacing the default) Calling VintageNet.configure/2 to change the configuration at run-time When vintage_net starts, it applies saved configurations first and if any thing is wrong with those configs, it reverts to the application config. A good practice is to have safe defaults for all network interfaces in the application config. The only required key in the configuration maps is :type. All other keys follow from the type. :type should be set to a module that implements the VintageNet.Technology behaviour. The following are included: VintageNet.Technology.Ethernet - Standard wired Ethernet VintageNet.Technology.WiFi - Client configurations for 802.11 WiFi VintageNet.Technology.Mobile - Cellular configurations (likely to be refactored to a separate library) VintageNet.Technology.Null - An empty configuration useful for turning off a configuration The following sections describe the types in more detail. Wired Ethernet Wired Ethernet interfaces typically have names like &quot;eth0&quot;, &quot;eth1&quot;, etc. when using Nerves. Currently only IPv4 support using DHCP is supported: %{type: VintageNet.Technology.Ethernet, ipv4: %{method: :dhcp}} For example, to set the configuration at runtime: iex&gt; VintageNet.configure(&quot;eth0&quot;, %{type: VintageNet.Technology.Ethernet, ipv4: %{method: :dhcp}}) :ok Wired Ethernet connections are monitored for Internet connectivity. When internet-connected, they are preferred over all other network technologies even when the others provide default gateways. WiFi WiFi network interfaces typically have names like &quot;wlan0&quot; or &quot;wlan1&quot; when using Nerves. Most of the time, there&#39;s only one WiFi interface and its &quot;wlan0&quot;. Some WiFi adapters expose separate interfaces for 2.4 GHz and 5 GHz and they can be configured independently. WiFi configuration looks like this: %{ type: VintageNet.Technology.WiFi, wifi: %{ key_mgmt: :wpa_psk, mode: :client, psk: &quot;a_passphrase_or_psk&quot;, ssid: &quot;my_network_ssid&quot; }, ipv4: %{method: :dhcp} } The :ipv4 key is the same as in Wired Ethernet and only DHCP is currently supported. The :wifi key has the following common fields: :key_mgmt - WiFi security mode (:wpa_psk for WPA2, :none for no password) :mode - :client (default) - Normal operation. Associate with an AP :adhoc - peer to peer mode :host - access point mode :psk - A WPA2 passphrase or the raw PSK. If a passphrase is passed in, it will be converted to a PSK and disgarded. :ssid - The SSID for the network See the official docs for the complete list of options. Here&#39;s an example: iex&gt; VintageNet.configure(&quot;wlan0&quot;, %{ type: VintageNet.Technology.WiFi, wifi: %{ key_mgmt: :wpa_psk, mode: :client, psk: &quot;a_passphrase_or_psk&quot;, ssid: &quot;my_network_ssid&quot; }, ipv4: %{method: :dhcp} }) Example of WEP: iex&gt; VintageNet.configure(&quot;wlan0&quot;, %{ type: VintageNet.Technology.WiFi, wifi: %{ ssid: &quot;my_network_ssid&quot;, wep_key0: &quot;42FEEDDEAFBABEDEAFBEEFAA55&quot;, key_mgmt: :none, wep_tx_keyidx: 0 }, ipv4: %{method: :dhcp} }) Example of WPA-EAP: iex&gt; VintageNet.configure(&quot;wlan0&quot;, %{ type: VintageNet.Technology.WiFi, wifi: %{ ssid: &quot;testing&quot;, key_mgmt: :wpa_eap, scan_ssid: 1, pairwise: &quot;CCMP TKIP&quot;, group: &quot;CCMP TKIP&quot;, eap: &quot;PEAP&quot;, identity: &quot;user1&quot;, password: &quot;supersecret&quot;, phase1: &quot;peapver=auto&quot;, phase2: &quot;MSCHAPV2&quot; }, ipv4: %{method: :dhcp} }) Example of access point mode: iex&gt; VintageNet.configure(&quot;wlan0&quot;, %{ type: VintageNet.Technology.WiFi, wifi: %{ mode: :host, ssid: &quot;test ssid&quot;, key_mgmt: :none }, ipv4: %{ method: :static, address: &quot;192.168.24.1&quot;, netmask: &quot;255.255.255.0&quot;, gateway: &quot;192.168.24.1&quot; }, dhcpd: %{ start: &quot;192.168.24.2&quot;, end: &quot;192.168.24.10&quot; } }) LTE"},{"ref":"readme.html#properties","title":"🍇 VintageNet - Properties","type":"extras","doc":"VintageNet maintains a key/value store for retrieving information on networking information: iex&gt; VintageNet.get([&quot;interface&quot;, &quot;eth0&quot;, :connection]) :internet iex&gt; VintageNet.get_by_prefix([]) [ {[&quot;interface&quot;, &quot;eth0&quot;, &quot;connection&quot;], :internet}, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;state&quot;], :configured}, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;type&quot;], VintageNet.Technology.Ethernet}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;connection&quot;], :internet}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;state&quot;], :configured}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;type&quot;], VintageNet.Technology.WiFi} ] You can also subscribe to keys and receive a message every time it or one its child keys changes: iex&gt; VintageNet.subscribe([&quot;interface&quot;, &quot;eth0&quot;]) :ok iex&gt; flush {VintageNet, [&quot;interface&quot;, &quot;eth0&quot;, &quot;state&quot;], :configuring, :configured, %{}} The message format is {VintageNet, name, old_value, new_value, metadata} Global properties PropertyValuesDescription available_interfaces[eth0, ...]Currently available network interfaces in priority order. E.g., the first one is used by default connection:disconnected, :lan, :internetThe overall network connection status. This is the best status of all interfaces. Common network interface properties All network interface properties can be found under [&quot;interface&quot;, ifname] in the PropertyTable. The following table lists out properties common to all interfaces: PropertyValuesDescription typeVintageNet.Technology.Ethernet, etc.The type of the interface state:configured, :configuring, etc.The state of the interface from VintageNet&#39;s point of view. connection:disconnected, :lan, :internetThis provides a determination of the Internet connection status ipv4IPv4 parametersThis is a map of IPv4 parameters on the interface. This includes IP address, subnet, gateway, etc. Specific types of interfaces provide more parameters. Wired Ethernet status No additional parameters WiFi status PropertyValuesDescription LTE status PropertyValuesDescription signal0 - 100This is a rough measure of signal strength from 0 (none) to 100 (all bars)"},{"ref":"readme.html#system-requirements","title":"🍇 VintageNet - System Requirements","type":"extras","doc":"Busybox Requirements CONFIG_UDHCPC=y - udhcpc DHCP Client CONFIG_UDHCPD=y - udhcpd DHCP Server (optional) CONFIG_IFUP=y - ifup CONFIG_IFDOWN=y ifdown CONFIG_RUN_PARTS=y CONFIG_MKTEMP=y Buildroot Requirements BR2_PACKAGE_WPA_SUPPLICANT BR2_PACKAGE_WPA_SUPPLICANT_CLI Additional Requirements for Access Point Mode BR2_PACKAGE_DNSMASQ or CONFIG_UDHCPD (in busybox) BR2_PACKAGE_HOSTAPD or BR2_PACKAGE_WPA_SUPPLICANT_HOTSPOT Additional Requirements for LTE Kernel modules (defconfig) CONFIG_PPP=m CONFIG_PPP_BSDCOMP=m CONFIG_PPP_DEFLATE=m CONFIG_PPP_ASYNC=m CONFIG_PPP_SYNC_TTY=m CONFIG_USB_NET_CDC_NCM=m CONFIG_USB_NET_HUAWEI_CDC_NCM=m CONFIG_USB_SERIAL_OPTION=m System deps pppd mknod"}]